*** /dev/null
--- b/src/backend/executor/nodeSamplescan.c
***************
*** 0 ****
--- 1,345 ----
+ /*-------------------------------------------------------------------------
+  *
+  * nodeSamplescan.c
+  *	  Support routines for sample scans of relations.
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  *
+  * IDENTIFICATION
+  *	  src/backend/executor/nodeSamplescan.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ /*
+  * INTERFACE ROUTINES
+  *		ExecSampleScan				randomly scans a relation.
+  *		ExecSampleNext				retrieve next tuple in the order depending on sampling method System/Bernoulli.
+  *		ExecInitSampleScan			creates and initializes a samplescan node.
+  *		ExecEndSampleScan			releases any storage allocated.
+  *		ExecReScanSampleScan		rescans the relation
+  *		ExecSampleMarkPos			marks scan position
+  *		ExecSampleRestrPos			restores scan position
+  */
+ #include "postgres.h"
+ 
+ #include <time.h>
+ 
+ #include "access/relscan.h"
+ #include "executor/execdebug.h"
+ #include "executor/nodeSamplescan.h"
+ #include "utils/rel.h"
+ #include "access/heapam.h"
+ #include "executor/executor.h"
+ #include "parser/parsetree.h"
+ #include "storage/bufmgr.h"
+ 
+ 
+ static void InitScanRelation(SampleScanState *node, EState *estate);
+ static TupleTableSlot *SampleNext(SampleScanState *node);
+ 
+ 
+ 
+ /* ----------------------------------------------------------------
+  *						Scan Support
+  * ----------------------------------------------------------------
+  */
+ 
+ /* ----------------------------------------------------------------
+  *		SampleNext
+  *
+  *		This is a workhorse for ExecSampleScan
+  * ----------------------------------------------------------------
+  */
+ static TupleTableSlot *
+ SampleNext(SampleScanState *node)
+ {
+ 	HeapTuple	tuple;
+ 	HeapScanDesc scandesc;
+ 	EState		 *estate;
+ 	ScanDirection	direction;
+ 	TupleTableSlot *slot;
+ 
+ 	/*
+ 	 * get information from the estate and scan state.
+ 	 */
+ 	scandesc = node->ss.ss_currentScanDesc;
+ 	estate = node->ss.ps.state;
+ 	direction = estate->es_direction;
+ 	slot = node->ss.ss_ScanTupleSlot;
+ 
+ 	tuple = heap_getnext(scandesc, direction); 
+ 
+ 	/*              
+ 	 * save the tuple and the buffer returned to us by the access methods in
+ 	 * our scan tuple slot and return the slot.  Note: we pass 'false' because
+ 	 * tuples returned by heap_getnext() are pointers onto disk pages and were
+ 	 * not created with palloc() and so should not be pfree()'d.  Note also
+ 	 * that ExecStoreTuple will increment the refcount of the buffer; the
+ 	 * refcount will not be dropped until the tuple table slot is cleared.
+ 	 */
+ 	if (tuple)
+ 		ExecStoreTuple(tuple,	/* tuple to store */
+ 					   slot,	/* slot to store in */
+ 					   scandesc->rs_cbuf,		/* buffer associated with this
+ 												 * tuple */
+ 					   false);	/* don't pfree this pointer */
+ 	else
+ 		ExecClearTuple(slot);
+ 
+ 	return slot;
+ }
+ 
+ /*
+  * SampleRecheck -- access method routine to recheck a tuple in EvalPlanQual.
+  * Same as SeqScan, should modify?
+  */
+ static bool
+ SampleRecheck(SampleScanState *node, TupleTableSlot *slot)
+ {
+ 	return true;
+ }
+ 
+ /* ----------------------------------------------------------------
+  *		ExecSampleScan(node)
+  *
+  *		Return the next tuple in the sample scan's result set
+  *		We call the ExecScan() routine and pass it the appropriate
+  *		access method functions.
+  * ----------------------------------------------------------------
+  */
+ TupleTableSlot *
+ ExecSampleScan(SampleScanState *node)
+ {
+ 	return ExecScan((ScanState *) node,
+ 				(ExecScanAccessMtd) SampleNext,
+ 				(ExecScanRecheckMtd) SampleRecheck);
+ }
+ 
+ /* ----------------------------------------------------------------
+  *		InitScanRelation
+  *
+  *		This does the initialization for scan relations and
+  *		subplans of scans.
+  * ----------------------------------------------------------------
+  */
+ static void
+ InitScanRelation(SampleScanState *node, EState *estate)
+ {
+ 	Relation	currentRelation;
+ 	HeapScanDesc currentScanDesc;
+ 
+ 	/*
+ 	 * get the relation object id from the relid'th entry in the range table,
+ 	 * open that relation and acquire appropriate lock on it.
+ 	 */
+ 	currentRelation = ExecOpenScanRelation(estate,
+ 									 ((SampleScan *) node->ss.ps.plan)->scan.scanrelid);
+ 
+ 	currentScanDesc = heap_beginscan(currentRelation,
+ 									 estate->es_snapshot,
+ 									 0,
+ 									 NULL);
+ 
+ 	node->ss.ss_currentRelation = currentRelation;
+ 	node->ss.ss_currentScanDesc = currentScanDesc;
+ 
+ 	ExecAssignScanType(&node->ss, RelationGetDescr(currentRelation));
+ }
+ 
+ /* ----------------------------------------------------------------
+  *		ExecInitSampleScan
+  * ----------------------------------------------------------------
+  */
+ SampleScanState *
+ ExecInitSampleScan(SampleScan *node, EState *estate, int eflags)
+ {
+ 	SampleScanState *scanstate;
+ 	TableSampleMethod sample_method = node->sample_info->sample_method;
+ 	int				  sample_percent = node->sample_info->sample_percent;
+ 	double				  seed;
+ 
+ 	/*
+ 	 * We don't expect to have any child plan node
+ 	 */
+ 	Assert(outerPlan(node) == NULL);
+ 	Assert(innerPlan(node) == NULL);
+ 
+ 	/*
+ 	 * create state structure
+ 	 */
+ 	scanstate = makeNode(SampleScanState);
+ 	scanstate->ss.ps.plan = (Plan *) node;
+ 	scanstate->ss.ps.state = estate;
+ 
+ 	/*
+ 	 * Miscellaneous initialization
+ 	 *
+ 	 * create expression context for node
+ 	 */
+ 	ExecAssignExprContext(estate, &scanstate->ss.ps);
+ 
+ 	/*
+ 	 * initialize child expressions
+ 	 */
+ 	scanstate->ss.ps.targetlist = (List *)
+ 		ExecInitExpr((Expr *) node->scan.plan.targetlist,
+ 					 (PlanState *) scanstate);
+ 	scanstate->ss.ps.qual = (List *)
+ 		ExecInitExpr((Expr *) node->scan.plan.qual,
+ 					 (PlanState *) scanstate);
+ 
+ 	/*
+ 	 * tuple table initialization
+ 	 */
+ 	ExecInitResultTupleSlot(estate, &scanstate->ss.ps);
+ 	ExecInitScanTupleSlot(estate, &scanstate->ss);
+ 
+ 	/*
+ 	 * initialize scan relation
+ 	 */
+ 	InitScanRelation(scanstate, estate);
+ 
+ 	/*
+ 	 * InitScanRelation cannot see sampleinfo, initialize below
+ 	 */
+ 	HeapScanDesc scan = scanstate->ss.ss_currentScanDesc;
+ 
+ 	scan->is_sample_scan = true;
+ 	scan->sample_percent = sample_percent;
+ 	scan->sample_method = sample_method;
+ 
+ 	scanstate->ss.ps.ps_TupFromTlist = false;
+ 
+ 	/*
+ 	 * Initialize result tuple type and projection info.
+ 	 */
+ 	ExecAssignResultTypeFromTL(&scanstate->ss.ps);
+ 	ExecAssignScanProjectionInfo(&scanstate->ss);
+ 
+ 	/*
+ 	 * Initialize fields of SampleScanState for BERNOULLI
+ 	 */
+ 	if(sample_method == SAMPLE_BERNOULLI)
+ 	{
+ 		double numtuples = scan->rs_rd->rd_rel->reltuples;
+ 		int targrows = (int)floor(numtuples*sample_percent/100 + 0.5);
+ 
+ 		scan->targrows = targrows;
+ 		scan->rs_samplerows = (HeapTuple *)palloc(targrows * sizeof(HeapTuple));
+ 		scan->rs_curindex = 0;
+ 		scan->rs_samplesize = 0;
+ 		scan->rs_sampleinited = false;
+ 	}
+ 
+ 	/*
+ 	 * Setup PRNG state; seed with the REPEATABLE clause, if any. We
+ 	 * can't just use srandom(), since there could be multiple
+ 	 * concurrent sample scans.
+ 	 *
+ 	 * XXX: using time() to seed the PRNG in the non-repeatable case
+ 	 * could probably be improved. Different state array sizes could
+ 	 * also be tried: do we need high-quality random numbers?
+ 	 */
+ 	if(node->sample_info->is_repeatable)
+ 		seed = node->sample_info->repeat_seed;
+ 	else
+ 		seed = time(NULL);
+ 
+ 	sample_set_seed(scan->rs_randstate, seed);
+ 
+ 	return scanstate;
+ }
+ 
+ /* ----------------------------------------------------------------
+  *						Join Support
+  * XXX: This part needs more work.
+  * 1. To understand , read at execAmi.c, ExecSupportsMarkRestore
+  * 2. The below part is still seqscan code, not changed yet.
+  * 3. ReScan is needed by join methods, Others used by MergeJoin
+  * 4. In Optimizer, the Join support also needs update, like row 
+  *    estimate, cost estimate, and join cost estimate, needs to 
+  *    go better.
+  * ----------------------------------------------------------------
+  */
+ 
+ /* ----------------------------------------------------------------
+  *		ExecReScanSampleScan
+  *
+  *		Rescans the relation.
+  * ----------------------------------------------------------------
+  */
+ void
+ ExecReScanSampleScan(SampleScanState *node)
+ {
+ 	HeapScanDesc scan;
+ 
+ 	scan = node->ss.ss_currentScanDesc;
+ 
+ 	heap_rescan(scan,			/* scan desc */
+ 				NULL);			/* new scan keys */
+ 
+ 	ExecScanReScan((ScanState *) node);
+ }
+ 
+ /* ----------------------------------------------------------------
+  *		ExecSampleMarkPos(node)
+  *
+  *		Marks scan position.
+  * ----------------------------------------------------------------
+  */
+ void
+ ExecSampleMarkPos(SampleScanState *node)
+ {
+ 	HeapScanDesc scan = node->ss.ss_currentScanDesc;
+ 
+ 	heap_markpos(scan);
+ }
+ 
+ /* ----------------------------------------------------------------
+  *		ExecSampleRestrPos
+  *
+  *		Restores scan position.
+  * ----------------------------------------------------------------
+  */
+ void
+ ExecSampleRestrPos(SampleScanState *node)
+ {
+ 	HeapScanDesc scan = node->ss.ss_currentScanDesc;
+ 
+ 	/*
+ 	 * Clear any reference to the previously returned tuple.  This is needed
+ 	 * because the slot is simply pointing at scan->rs_cbuf, which
+ 	 * heap_restrpos will change; we'd have an internally inconsistent slot if
+ 	 * we didn't do this.
+ 	 */
+ 	ExecClearTuple(node->ss.ss_ScanTupleSlot);
+ 
+ 	heap_restrpos(scan);
+ }
+ 
+ /*
+  * Shutdown this scan. This function should generally be symmetric with
+  * ExecInitSampleScan(): we ought to clean up after ourselves.
+  */
+ void
+ ExecEndSampleScan(SampleScanState *node)
+ {
+ 	ExecFreeExprContext(&node->ss.ps);
+ 
+ 	ExecClearTuple(node->ss.ps.ps_ResultTupleSlot);
+ 	ExecClearTuple(node->ss.ss_ScanTupleSlot);
+ 
+ 	/*
+ 	 * Close heap scan
+ 	 */
+ 	heap_endscan(node->ss.ss_currentScanDesc);
+ 
+ 	/*
+ 	 * Note that ExecCloseScanRelation() does NOT release the lock we
+ 	 * acquired on the scan relation: it is held until the end of the
+ 	 * transaction.
+ 	 */
+ 	ExecCloseScanRelation(node->ss.ss_currentRelation);
+ }
*** a/src/backend/nodes/copyfuncs.c
--- b/src/backend/nodes/copyfuncs.c
***************
*** 350,355 **** _copySeqScan(const SeqScan *from)
--- 350,373 ----
  }
  
  /*
+  * _copySampleScan
+  */
+ static SampleScan *
+ _copySampleScan(const SampleScan *from)
+ {
+ 	SampleScan *newnode = makeNode(SampleScan);
+ 
+ 	/*
+ 	 * copy node superclass fields
+ 	 */
+ 	CopyScanFields((const Scan *) from, (Scan *) newnode);
+ 
+ 	COPY_NODE_FIELD(sample_info);
+ 
+ 	return newnode;
+ }
+ 
+ /*
   * _copyIndexScan
   */
  static IndexScan *
***************
*** 1013,1018 **** _copyRangeVar(const RangeVar *from)
--- 1031,1037 ----
  	COPY_SCALAR_FIELD(inhOpt);
  	COPY_SCALAR_FIELD(relpersistence);
  	COPY_NODE_FIELD(alias);
+ 	COPY_NODE_FIELD(sample_info);
  	COPY_LOCATION_FIELD(location);
  
  	return newnode;
***************
*** 1804,1809 **** _copyFromExpr(const FromExpr *from)
--- 1823,1846 ----
  	return newnode;
  }
  
+ 
+ /*
+  * _CopyTableSampleInfo
+  */
+ static TableSampleInfo *
+ _copyTableSampleInfo(const TableSampleInfo *from)
+ {
+ 	TableSampleInfo *newnode = makeNode(TableSampleInfo);
+ 
+ 	COPY_SCALAR_FIELD(sample_percent);
+ 	COPY_SCALAR_FIELD(sample_method);
+ 	COPY_SCALAR_FIELD(is_repeatable);
+ 	COPY_SCALAR_FIELD(repeat_seed);
+ 
+ 	return newnode;
+ }
+ 
+ 
  /* ****************************************************************
   *						relation.h copy functions
   *
***************
*** 1955,1960 **** _copyRangeTblEntry(const RangeTblEntry *from)
--- 1992,1998 ----
  	COPY_SCALAR_FIELD(rtekind);
  	COPY_SCALAR_FIELD(relid);
  	COPY_SCALAR_FIELD(relkind);
+ 	COPY_NODE_FIELD(sample_info);
  	COPY_NODE_FIELD(subquery);
  	COPY_SCALAR_FIELD(security_barrier);
  	COPY_SCALAR_FIELD(jointype);
***************
*** 3867,3872 **** copyObject(const void *from)
--- 3905,3913 ----
  		case T_ValuesScan:
  			retval = _copyValuesScan(from);
  			break;
+ 		case T_SampleScan:
+ 			retval = _copySampleScan(from);
+ 			break;
  		case T_CteScan:
  			retval = _copyCteScan(from);
  			break;
***************
*** 4066,4071 **** copyObject(const void *from)
--- 4107,4115 ----
  		case T_FromExpr:
  			retval = _copyFromExpr(from);
  			break;
+ 		case T_TableSampleInfo:
+ 			retval = _copyTableSampleInfo(from);
+ 			break;
  
  			/*
  			 * RELATION NODES
*** a/src/backend/nodes/equalfuncs.c
--- b/src/backend/nodes/equalfuncs.c
***************
*** 107,112 **** _equalRangeVar(const RangeVar *a, const RangeVar *b)
--- 107,113 ----
  	COMPARE_SCALAR_FIELD(relpersistence);
  	COMPARE_NODE_FIELD(alias);
  	COMPARE_LOCATION_FIELD(location);
+ 	COMPARE_NODE_FIELD(sample_info);
  
  	return true;
  }
***************
*** 777,782 **** _equalFromExpr(const FromExpr *a, const FromExpr *b)
--- 778,794 ----
  	return true;
  }
  
+ static bool
+ _equalTableSampleInfo(TableSampleInfo *a, TableSampleInfo *b)
+ {
+ 	COMPARE_SCALAR_FIELD(sample_percent);
+ 	COMPARE_SCALAR_FIELD(sample_method);
+ 	COMPARE_SCALAR_FIELD(is_repeatable);
+ 	COMPARE_SCALAR_FIELD(repeat_seed);
+ 
+ 	return true;
+ }
+ 
  
  /*
   * Stuff from relation.h
***************
*** 2271,2276 **** _equalRangeTblEntry(const RangeTblEntry *a, const RangeTblEntry *b)
--- 2283,2289 ----
  	COMPARE_SCALAR_FIELD(rtekind);
  	COMPARE_SCALAR_FIELD(relid);
  	COMPARE_SCALAR_FIELD(relkind);
+ 	COMPARE_NODE_FIELD(sample_info);
  	COMPARE_NODE_FIELD(subquery);
  	COMPARE_SCALAR_FIELD(security_barrier);
  	COMPARE_SCALAR_FIELD(jointype);
***************
*** 2630,2635 **** equal(const void *a, const void *b)
--- 2643,2651 ----
  		case T_JoinExpr:
  			retval = _equalJoinExpr(a, b);
  			break;
+ 		case T_TableSampleInfo:
+ 			retval = _equalTableSampleInfo(a, b);
+ 			break;
  
  			/*
  			 * RELATION NODES
*** a/src/backend/nodes/outfuncs.c
--- b/src/backend/nodes/outfuncs.c
***************
*** 437,442 **** _outSeqScan(StringInfo str, const SeqScan *node)
--- 437,452 ----
  }
  
  static void
+ _outSampleScan(StringInfo str, const SampleScan *node)
+ {
+ 	WRITE_NODE_TYPE("SAMPLESCAN");
+ 
+ 	_outScanInfo(str, (const Scan *) node);
+ 
+ 	WRITE_NODE_FIELD(sample_info);
+ }
+ 
+ static void
  _outIndexScan(StringInfo str, const IndexScan *node)
  {
  	WRITE_NODE_TYPE("INDEXSCAN");
***************
*** 880,885 **** _outRangeVar(StringInfo str, const RangeVar *node)
--- 890,896 ----
  	WRITE_CHAR_FIELD(relpersistence);
  	WRITE_NODE_FIELD(alias);
  	WRITE_LOCATION_FIELD(location);
+ 	WRITE_NODE_FIELD(sample_info);
  }
  
  static void
***************
*** 1749,1754 **** _outRelOptInfo(StringInfo str, const RelOptInfo *node)
--- 1760,1766 ----
  	WRITE_FLOAT_FIELD(allvisfrac, "%.6f");
  	WRITE_NODE_FIELD(subplan);
  	WRITE_NODE_FIELD(subroot);
+ 	WRITE_BOOL_FIELD(has_table_sample);
  	/* we don't try to print fdwroutine or fdw_private */
  	WRITE_NODE_FIELD(baserestrictinfo);
  	WRITE_NODE_FIELD(joininfo);
***************
*** 2330,2335 **** _outRangeTblEntry(StringInfo str, const RangeTblEntry *node)
--- 2342,2348 ----
  		case RTE_RELATION:
  			WRITE_OID_FIELD(relid);
  			WRITE_CHAR_FIELD(relkind);
+ 			WRITE_NODE_FIELD(sample_info);
  			break;
  		case RTE_SUBQUERY:
  			WRITE_NODE_FIELD(subquery);
***************
*** 2372,2377 **** _outRangeTblEntry(StringInfo str, const RangeTblEntry *node)
--- 2385,2401 ----
  }
  
  static void
+ _outTableSampleInfo(StringInfo str, TableSampleInfo *node)
+ {
+ 	WRITE_NODE_TYPE("TABLESAMPLE");
+ 
+ 	WRITE_INT_FIELD(sample_percent);
+ 	WRITE_ENUM_FIELD(sample_method, TableSampleMethod);
+ 	WRITE_INT_FIELD(repeat_seed);
+ 	WRITE_BOOL_FIELD(is_repeatable);
+ }
+ 
+ static void
  _outAExpr(StringInfo str, const A_Expr *node)
  {
  	WRITE_NODE_TYPE("AEXPR");
***************
*** 2762,2767 **** _outNode(StringInfo str, const void *obj)
--- 2786,2794 ----
  			case T_ValuesScan:
  				_outValuesScan(str, obj);
  				break;
+ 			case T_SampleScan:
+ 				_outSampleScan(str, obj);
+ 				break;
  			case T_CteScan:
  				_outCteScan(str, obj);
  				break;
***************
*** 3148,3153 **** _outNode(StringInfo str, const void *obj)
--- 3175,3183 ----
  			case T_Constraint:
  				_outConstraint(str, obj);
  				break;
+ 			case T_TableSampleInfo:
+ 				_outTableSampleInfo(str, obj);
+ 				break;
  			case T_FuncCall:
  				_outFuncCall(str, obj);
  				break;
*** a/src/backend/nodes/readfuncs.c
--- b/src/backend/nodes/readfuncs.c
***************
*** 380,385 **** _readRangeVar(void)
--- 380,399 ----
  	READ_CHAR_FIELD(relpersistence);
  	READ_NODE_FIELD(alias);
  	READ_LOCATION_FIELD(location);
+ 	READ_NODE_FIELD(sample_info);
+ 
+ 	READ_DONE();
+ }
+ 
+ static TableSampleInfo *
+ _readTableSampleInfo(void)
+ {
+ 	READ_LOCALS(TableSampleInfo);
+ 
+ 	READ_INT_FIELD(sample_percent);
+ 	READ_ENUM_FIELD(sample_method, TableSampleMethod);
+ 	READ_BOOL_FIELD(is_repeatable);
+ 	READ_INT_FIELD(repeat_seed);
  
  	READ_DONE();
  }
***************
*** 1189,1194 **** _readRangeTblEntry(void)
--- 1203,1209 ----
  		case RTE_RELATION:
  			READ_OID_FIELD(relid);
  			READ_CHAR_FIELD(relkind);
+ 			READ_NODE_FIELD(sample_info);
  			break;
  		case RTE_SUBQUERY:
  			READ_NODE_FIELD(subquery);
***************
*** 1270,1275 **** parseNodeString(void)
--- 1285,1292 ----
  		return_value = _readAlias();
  	else if (MATCH("RANGEVAR", 8))
  		return_value = _readRangeVar();
+ 	else if (MATCH("TABLESAMPLE", 11))
+ 		return_value = _readTableSampleInfo();
  	else if (MATCH("INTOCLAUSE", 10))
  		return_value = _readIntoClause();
  	else if (MATCH("VAR", 3))
*** a/src/backend/optimizer/path/allpaths.c
--- b/src/backend/optimizer/path/allpaths.c
***************
*** 376,389 **** set_plain_rel_size(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
  static void
  set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
  {
! 	/* Consider sequential scan */
! 	add_path(rel, create_seqscan_path(root, rel, NULL));
  
! 	/* Consider index scans */
! 	create_index_paths(root, rel);
  
! 	/* Consider TID scans */
! 	create_tidscan_paths(root, rel);
  
  	/* Now find the cheapest of the paths for this rel */
  	set_cheapest(rel);
--- 376,403 ----
  static void
  set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
  {
! 	/*
! 	 * If there's a TABLESAMPLE clause, we ONLY consider using a SampleScan.
! 	 * This could be improved: in some cicumstances it might make sense to do
! 	 * an IndexScan and then sample from the index scan's result set, for instance.
! 	 */
! 	if(rel->has_table_sample){
! 		/* We decide we are inside a cursor stmt. If yes, abort */
! 		if(root->glob->isCursorStmt)
! 			elog(ERROR,
! 					"Unsupported Cursor: No Tablesample should be queried under cursor!");
! 		add_path(rel, create_samplescan_path(root, rel));
! 	}else
! 	{
! 		/* Consider sequential scan */
! 		add_path(rel, create_seqscan_path(root, rel, NULL));
  
! 		/* Consider index scans */
! 		create_index_paths(root, rel);
  
! 		/* Consider TID scans */
! 		create_tidscan_paths(root, rel);
! 	}
  
  	/* Now find the cheapest of the paths for this rel */
  	set_cheapest(rel);
*** a/src/backend/optimizer/path/costsize.c
--- b/src/backend/optimizer/path/costsize.c
***************
*** 103,108 **** int			effective_cache_size = DEFAULT_EFFECTIVE_CACHE_SIZE;
--- 103,109 ----
  Cost		disable_cost = 1.0e10;
  
  bool		enable_seqscan = true;
+ bool		enable_samplescan = true;
  bool		enable_indexscan = true;
  bool		enable_indexonlyscan = true;
  bool		enable_bitmapscan = true;
***************
*** 214,219 **** cost_seqscan(Path *path, PlannerInfo *root,
--- 215,263 ----
  	path->total_cost = startup_cost + run_cost;
  }
  
+ 
+ /*
+  * cost_samplescan
+  *	  Determines and returns the cost of scanning a relation according to sample scan.
+  */
+ void
+ cost_samplescan(Path *path, PlannerInfo *root,
+ 			 RelOptInfo *baserel)
+ {
+ 	Cost			startup_cost = 0;
+ 	Cost			run_cost = 0;
+ 	Cost			cpu_per_tuple;
+ 	RangeTblEntry	*rte;
+ 	int				sample_percent;
+ 
+ 	/* Should only be applied to base relations */
+ 	Assert(baserel->relid > 0);
+ 	Assert(baserel->rtekind == RTE_RELATION);
+ 	Assert(path->pathtype == T_SampleScan);
+ 
+ 	rte = planner_rt_fetch(baserel->relid, root);
+ 	sample_percent = rte->sample_info->sample_percent;
+ 
+ 	/*
+ 	 * disk costs
+ 	 * When the sample percentage is close to 100, we're likely to
+ 	 * be doing purely sequantial I/O. Conversely, for small percentage
+ 	 * samples, we're doing random I/O. Fow now, just be conservative
+ 	 * and always assume that we need to do a random I/O for each
+ 	 * sampled block. Of course, this is quite bogus.
+ 	 */
+ 	run_cost += random_page_cost * baserel->pages * sample_percent/100;
+ 
+ 	/* CPU costs */
+ 	startup_cost += baserel->baserestrictcost.startup;
+ 	cpu_per_tuple = cpu_tuple_cost + baserel->baserestrictcost.per_tuple;
+ 	run_cost += cpu_per_tuple * baserel->tuples;
+ 
+ 	path->startup_cost = startup_cost;
+ 	path->total_cost = startup_cost + run_cost;
+ }
+ 
+ 
  /*
   * cost_index
   *	  Determines and returns the cost of scanning a relation using an index.
***************
*** 3416,3422 **** approx_tuple_count(PlannerInfo *root, JoinPath *path, List *quals)
   *
   * We set the following fields of the rel node:
   *	rows: the estimated number of output tuples (after applying
!  *		  restriction clauses).
   *	width: the estimated average output tuple width in bytes.
   *	baserestrictcost: estimated cost of evaluating baserestrictinfo clauses.
   */
--- 3460,3466 ----
   *
   * We set the following fields of the rel node:
   *	rows: the estimated number of output tuples (after applying
!  *		  restriction clauses and considering the effect of TABLESAMPLE).
   *	width: the estimated average output tuple width in bytes.
   *	baserestrictcost: estimated cost of evaluating baserestrictinfo clauses.
   */
***************
*** 3424,3429 **** void
--- 3468,3474 ----
  set_baserel_size_estimates(PlannerInfo *root, RelOptInfo *rel)
  {
  	double		nrows;
+ 	RangeTblEntry	*rte;
  
  	/* Should only be applied to base relations */
  	Assert(rel->relid > 0);
***************
*** 3435,3440 **** set_baserel_size_estimates(PlannerInfo *root, RelOptInfo *rel)
--- 3480,3496 ----
  							   JOIN_INNER,
  							   NULL);
  
+ 	/* Consider TABLESAMPLE, if any. We assume the live heap rows are
+ 	 * uniformly distributed over the heap: this is a bogus simplifying
+ 	 * assumption. Note that the executor will apply the TABLESAMPLE
+ 	 * clause before applying any restrictions, we assume that the 
+ 	 * restrictions have the same selectivity for the sampled sub-relation
+ 	 * as they do for the entire relation (which is somewhat reasonable).
+ 	 */
+ 	rte = planner_rt_fetch(rel->relid, root);
+ 	if(rte->sample_info)
+ 		nrows = nrows*(rte->sample_info->sample_percent/100);
+ 
  	rel->rows = clamp_row_est(nrows);
  
  	cost_qual_eval(&rel->baserestrictcost, rel->baserestrictinfo, root);
*** a/src/backend/optimizer/plan/createplan.c
--- b/src/backend/optimizer/plan/createplan.c
***************
*** 55,60 **** static Material *create_material_plan(PlannerInfo *root, MaterialPath *best_path
--- 55,62 ----
  static Plan *create_unique_plan(PlannerInfo *root, UniquePath *best_path);
  static SeqScan *create_seqscan_plan(PlannerInfo *root, Path *best_path,
  					List *tlist, List *scan_clauses);
+ static SampleScan *create_samplescan_plan(PlannerInfo *root, Path *best_path,
+ 						List *tlist, List *scan_clauses);
  static Scan *create_indexscan_plan(PlannerInfo *root, IndexPath *best_path,
  					  List *tlist, List *scan_clauses, bool indexonly);
  static BitmapHeapScan *create_bitmap_scan_plan(PlannerInfo *root,
***************
*** 93,98 **** static List *order_qual_clauses(PlannerInfo *root, List *clauses);
--- 95,101 ----
  static void copy_path_costsize(Plan *dest, Path *src);
  static void copy_plan_costsize(Plan *dest, Plan *src);
  static SeqScan *make_seqscan(List *qptlist, List *qpqual, Index scanrelid);
+ static SampleScan *make_samplescan(PlannerInfo *root, List *qptlist, List *qpqual, Index scanrelid);
  static IndexScan *make_indexscan(List *qptlist, List *qpqual, Index scanrelid,
  			   Oid indexid, List *indexqual, List *indexqualorig,
  			   List *indexorderby, List *indexorderbyorig,
***************
*** 214,219 **** create_plan_recurse(PlannerInfo *root, Path *best_path)
--- 217,223 ----
  	switch (best_path->pathtype)
  	{
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_IndexScan:
  		case T_IndexOnlyScan:
  		case T_BitmapHeapScan:
***************
*** 326,331 **** create_scan_plan(PlannerInfo *root, Path *best_path)
--- 330,342 ----
  												scan_clauses);
  			break;
  
+ 		case T_SampleScan:
+ 			plan = (Plan *) create_samplescan_plan(root,
+ 													best_path,
+ 													tlist,
+ 													scan_clauses);
+ 			break;
+ 
  		case T_IndexScan:
  			plan = (Plan *) create_indexscan_plan(root,
  												  (IndexPath *) best_path,
***************
*** 512,517 **** disuse_physical_tlist(Plan *plan, Path *path)
--- 523,529 ----
  	switch (path->pathtype)
  	{
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_IndexScan:
  		case T_IndexOnlyScan:
  		case T_BitmapHeapScan:
***************
*** 1089,1094 **** create_seqscan_plan(PlannerInfo *root, Path *best_path,
--- 1101,1146 ----
  }
  
  /*
+  * create_samplescan_plan
+  *	 Returns a samplescan plan for the base relation scanned by 'best_path'
+  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
+  */
+ static SampleScan *
+ create_samplescan_plan(PlannerInfo *root, Path *best_path,
+ 					List *tlist, List *scan_clauses)
+ {
+ 	SampleScan    *scan_plan;
+ 	Index		scan_relid = best_path->parent->relid;
+ 
+ 	/* it should be a base rel... */
+ 	Assert(scan_relid > 0);
+ 	Assert(best_path->parent->rtekind == RTE_RELATION);
+ 	Assert(best_path->pathtype == T_SampleScan);
+ 
+ 	/* Sort clauses into best execution order */
+ 	scan_clauses = order_qual_clauses(root, scan_clauses);
+ 
+ 	/* Reduce RestrictInfo list to bare expressions; ignore pseudoconstants */
+ 	scan_clauses = extract_actual_clauses(scan_clauses, false);
+ 
+ 	/* Replace any outer-relation variables with nestloop params */
+ 	if (best_path->param_info)
+ 	{
+ 		scan_clauses = (List *)
+ 			replace_nestloop_params(root, (Node *) scan_clauses);
+ 	}
+ 
+ 	scan_plan = make_samplescan(root, tlist,
+ 							 scan_clauses,
+ 							 scan_relid);
+ 
+ 	copy_path_costsize(&scan_plan->scan.plan, best_path);
+ 
+ 	return scan_plan;
+ }
+ 
+ 
+ /*
   * create_indexscan_plan
   *	  Returns an indexscan plan for the base relation scanned by 'best_path'
   *	  with restriction clauses 'scan_clauses' and targetlist 'tlist'.
***************
*** 3167,3172 **** make_seqscan(List *qptlist,
--- 3219,3253 ----
  	return node;
  }
  
+ 
+ static SampleScan *
+ make_samplescan(PlannerInfo *root,
+ 			 List *qptlist,
+ 			 List *qpqual,
+ 			 Index scanrelid)
+ {
+ 	SampleScan    *node = makeNode(SampleScan);
+ 	Plan	   *plan = &node->scan.plan;
+ 	RangeTblEntry *rte;
+ 
+ 	/* cost should be inserted by caller */
+ 	plan->targetlist = qptlist;
+ 	plan->qual = qpqual;
+ 	plan->lefttree = NULL;
+ 	plan->righttree = NULL;
+ 	node->scan.scanrelid = scanrelid;
+ 
+ 	/*
+ 	 * For the convenience of nodeSamplescan.c, we stash a pointer to
+ 	 * the TableSampleInfo for this SampleScan in the SampleScan's
+ 	 * plan node.
+ 	 */
+ 	rte = planner_rt_fetch(scanrelid, root);
+ 	node->sample_info = rte->sample_info;
+ 
+ 	return node;
+ }
+ 
  static IndexScan *
  make_indexscan(List *qptlist,
  			   List *qpqual,
*** a/src/backend/optimizer/plan/planner.c
--- b/src/backend/optimizer/plan/planner.c
***************
*** 163,168 **** standard_planner(Query *parse, int cursorOptions, ParamListInfo boundParams)
--- 163,171 ----
  	glob->lastPHId = 0;
  	glob->lastRowMarkId = 0;
  	glob->transientPlan = false;
+ 	if(cursorOptions)
+ 		glob->isCursorStmt = true;
+ 	else glob->isCursorStmt = false;
  
  	/* Determine what fraction of the plan is likely to be scanned */
  	if (cursorOptions & CURSOR_OPT_FAST_PLAN)
*** a/src/backend/optimizer/plan/setrefs.c
--- b/src/backend/optimizer/plan/setrefs.c
***************
*** 306,311 **** set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
--- 306,322 ----
  					fix_scan_list(root, splan->plan.qual, rtoffset);
  			}
  			break;
+ 		case T_SampleScan:
+ 			{
+ 				SampleScan     *splan = (SampleScan *) plan;
+ 
+ 				splan->scan.scanrelid += rtoffset;
+ 				splan->scan.plan.targetlist -
+ 					fix_scan_list(root, splan->scan.plan.targetlist, rtoffset);
+ 				splan->scan.plan.qual =
+ 					fix_scan_list(root, splan->scan.plan.qual, rtoffset);
+ 			}
+ 			break;
  		case T_IndexScan:
  			{
  				IndexScan  *splan = (IndexScan *) plan;
*** a/src/backend/optimizer/plan/subselect.c
--- b/src/backend/optimizer/plan/subselect.c
***************
*** 2082,2087 **** finalize_plan(PlannerInfo *root, Plan *plan, Bitmapset *valid_params,
--- 2082,2091 ----
  			context.paramids = bms_add_members(context.paramids, scan_params);
  			break;
  
+ 		case T_SampleScan:
+ 			context.paramids = bms_add_members(context.paramids, scan_params);
+ 			break;
+ 
  		case T_IndexScan:
  			finalize_primnode((Node *) ((IndexScan *) plan)->indexqual,
  							  &context);
*** a/src/backend/optimizer/util/pathnode.c
--- b/src/backend/optimizer/util/pathnode.c
***************
*** 747,752 **** create_seqscan_path(PlannerInfo *root, RelOptInfo *rel, Relids required_outer)
--- 747,774 ----
  	return pathnode;
  }
  
+ 
+ /*
+  * create_samplescan_path
+  *	  Creates a path corresponding to a sample scan, returning the
+  *	  pathnode.
+  *	  Forked from create_seqscan_path, maybe there are other attributes needed.
+  */
+ Path *
+ create_samplescan_path(PlannerInfo *root, RelOptInfo *rel)
+ {
+ 	Path	   *pathnode = makeNode(Path);
+ 
+ 	pathnode->pathtype = T_SampleScan;
+ 	pathnode->parent = rel;
+ 	pathnode->pathkeys = NIL;
+ 
+ 	cost_samplescan(pathnode, root, rel);
+ 
+ 	return pathnode;
+ }
+ 
+ 
  /*
   * create_index_path
   *	  Creates a path node for an index scan.
***************
*** 2072,2077 **** reparameterize_path(PlannerInfo *root, Path *path,
--- 2094,2101 ----
  	{
  		case T_SeqScan:
  			return create_seqscan_path(root, rel, required_outer);
+ 		case T_SampleScan:
+ 			return create_samplescan_path(root, rel);
  		case T_IndexScan:
  		case T_IndexOnlyScan:
  			{
*** a/src/backend/optimizer/util/relnode.c
--- b/src/backend/optimizer/util/relnode.c
***************
*** 117,122 **** build_simple_rel(PlannerInfo *root, int relid, RelOptKind reloptkind)
--- 117,123 ----
  	rel->subroot = NULL;
  	rel->fdwroutine = NULL;
  	rel->fdw_private = NULL;
+ 	rel->has_table_sample = (rte->sample_info != NULL);
  	rel->baserestrictinfo = NIL;
  	rel->baserestrictcost.startup = 0;
  	rel->baserestrictcost.per_tuple = 0;
***************
*** 373,378 **** build_join_rel(PlannerInfo *root,
--- 374,380 ----
  	joinrel->subroot = NULL;
  	joinrel->fdwroutine = NULL;
  	joinrel->fdw_private = NULL;
+ 	joinrel->has_table_sample = false;
  	joinrel->baserestrictinfo = NIL;
  	joinrel->baserestrictcost.startup = 0;
  	joinrel->baserestrictcost.per_tuple = 0;
